
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 262144;

int N, K;
int by [MAXN];
unsigned sum [MAXN];
unsigned best [MAXN];

void read ()
{
    scanf ("%d %d", &N, &K);
    sum [0] = 0;
    for (int i = 0; i < N; ++i)
    {
        scanf ("%u", &sum [i + 1]);
        sum [i + 1] += sum [i];
    }
    for (int i = 1; i <= 5; ++i)
        sum [N + i] = sum [N + i - 1];
    N += 5;
}

inline bool update (unsigned &a, unsigned b)
{
    return (a < b ? a = b, true : false);
}

unsigned solve ()
{
    best [0] = 0;
    for (int i = 0; i < N; ++i)
        for (int j = 0; j <= K && i + j + 1 <= N; ++j)
            if (update (best [i + j + 1], best [i] + sum [i + j] - sum [i]))
                by [i + j + 1] = j;
    
    return best [N];
}

int main ()
{
    read ();
    printf ("%u\n", solve ());
    return 0;
}
