#include <iostream>
#include <cstdlib>
#include <cmath>

using namespace std;

struct point 
{
	double x,y;
};

struct zaraza
{
	point b,e;
}mas[128];

int l,n;

bool isitbad(point a,point b,point c)
{
	double ret=a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);
	if(ret<0) ret*=-1;
	double dist=sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
	double h=ret/dist;
	if(h>50.0) return 0;
	return 1;
}

void solve()
{
	int j;
	double len=(double) l+0.0000000000001;
	point tr;
	for(int i=0;i<50000;i++)
	{
		
		tr.x= (double)(rand()%l);
		tr.y= (double)(rand()%l);
		tr.x+= (rand()%2000000)/2000000.0;
		tr.y+= (rand()%2000000)/2000000.0;
		
		for(j=0;j<n;j++)
		{
			if(isitbad(mas[j].b,mas[j].e,tr)) break;
		}
		if(j==n)
		{
			printf("%lf %lf\n",tr.x,tr.y);
			return;
		}
	}
	printf("NO WAY\n");
}

void read()
{
	scanf("%d",&l);
	scanf("%d",&n);
	for(int i=0;i<n;i++)
		scanf("%lf %lf %lf %lf",&mas[i].b.x,&mas[i].b.y,&mas[i].e.x,&mas[i].e.y);
}

int main()
{
	read();
	solve();
	return 0;
}
