#include <iostream>
#include <cmath>

using namespace std;

int n,l;
double A[101][4];
int resx=-1,resy=-1;

double S(double &ax, double &ay, double &bx, double &by,double cx, double cy)
{ return ((ax-bx)*(ay+by)+(bx-cx)*(by+cy)+(cx-ax)*(cy+ay)); }

double hypo(double &ax,double &ay,double bx,double by)
{ return sqrt((ax-bx)*(ax-bx)+(ay-by)*(ay-by)); } 

double dist(int &x,int &y,int &ind)
{
 double s=S(A[ind][0],A[ind][1],A[ind][2],A[ind][3],(double)x,(double)y);
 if(s<0) s=-s;
 
 if(s==0) return min(hypo(A[ind][0],A[ind][1],x,y),hypo(A[ind][2],A[ind][3],x,y));
 
 return (double)s/(double) hypo(A[ind][0],A[ind][1],A[ind][2],A[ind][3]);      
}

int main()
{
 scanf("%d",&l);
 scanf("%d",&n);
 for(int i=0;i<n;i++)
     cin>>A[i][0]>>A[i][1]>>A[i][2]>>A[i][3];
 
 for(int i=0;i<=l;i++)
    for(int j=0;j<=l;j++)
        {
         bool answ=1;
         for(int k=0;k<n;k++)
              if(dist(i,j,k)<=50.0)  {answ=0;break;}
              
         if(answ) {resx=i; resy=j; goto end;}   
        }
 
 end:
 if(resx==-1) cout<<"NO WAY"<<endl;
 else cout<<resx<<" "<<resy<<endl;

 return 0;
}
