#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 18;

int n , k;
int a[MAXN];

unsigned int s[MAXN];
unsigned int dp[MAXN];

int q[MAXN];

void read() {
	int i;
	
	scanf ("%d%d",&n,&k);
	for (i=1;i<=n;i++) {
		scanf ("%d",&a[i]);
		s[i] = s[i - 1] + (unsigned int)a[i];
	}
}

inline unsigned int sc ( int l , int r ) {
	if ( l == -1 ) return s[r] - s[ max ( l + 1 , r - k ) ];
	return dp[l] + s[r] - s[ max ( l + 1 , r - k ) ];
}

inline int cmp ( int q , int w ) {
	int l , r;
	int mid;
	
	l = 0;
	r = n + 1;
	
	while ( l < r ) {
		mid = l + (r - l + 1) / 2;
		
		if ( sc ( q , mid ) >= sc ( w , mid ) )
			l = mid;
		else
			r = mid - 1;
	}
	
	return l;
}

void solve() {
	int i;
	int l , r;
		
	q[l = r = 0] = -1;
	for (i=1;i<=n;i++) {
		if ( r - l > 0 && cmp ( q[l] , q[l + 1] ) < i ) ++ l;
		
		dp[i] = sc ( q[l] , i );
		
		q[ ++ r ] = i - 1;
		while ( r - l > 1 && cmp ( q[r - 2] , q[r - 1] ) > cmp ( q[r - 1] , q[r] ) )
			q[r - 1] = q[r --];
	}
	
	printf ("%u\n",dp[n]);
}

int main() {
	read();
	solve();
	
	return 0;
}
