#include <cstdio>
#include <cmath>

using namespace std;

struct Point
{ double x, y; };

bool flag=false;
int L, N;
Point A_start[128];
Point A_end[128];

inline double scal(Point a, Point b)
{ return -a.y*b.x-a.x*b.y; }

inline double mod(double temp)
{ return (temp >= 0) ? temp : -temp; }

bool ok(double x, double y)
{
     Point v1, v2;
     double dist, x1, y1, check;
     
     for (int i=0; i<N; ++i)
     {
          v1.x=A_end[i].x-A_start[i].x;
          v1.y=A_end[i].y-A_start[i].y;
          v2.x=x-A_start[i].x;
          v2.y=y-A_start[i].y;
          x1=A_end[i].x-A_start[i].x;
          y1=A_end[i].y-A_start[i].x;
          x1*=x1;
          y1*=y1;
          dist=x1+y1;
          dist=sqrt(dist);
          check=scal(v1, v2)/dist;
          check=mod(check);
          if (check <= 50)
             return false;
     }
     return true;
}

void solve()
{
     for (int i=0; i<=L; ++i)
     {
         for (int j=0; j<=L; ++j)
         {
             if (ok(i, j))
             {
                flag=true;
                printf("%d %d\n", i, j);
                break;
             }
         }
         if (flag)
            break;
     }
     if (!flag)
        printf("NO WAY\n");
}

void input()
{
     scanf("%d", &L);
     scanf("%d", &N);
     for (int i=0; i<N; ++i)
         scanf("%lf%lf%lf%lf", &A_start[i].x, &A_start[i].y, &A_end[i].x, &A_end[i].y);
}

int main()
{
    input();
    solve();
return 0;
}
