#include <stdio.h>
#include <algorithm>
#include <iostream>
using namespace std;

long long DP[200005];
int A[200001];
long long sum[200001];
int root[200003];
int N, K;

int dp(int k)
{
    if (k >= N) return 0;
    long long &ret = DP[k];
    if (ret != -1) return ret;
    
    for (int i = k; i <= N && i <= k + K && i <= root[k + 1]; i++) 
    {
        int t = sum[i] - sum[k] + dp(i + 1);
        if (t > ret) ret = t, root[k] = i;
    }
    return ret;
}
int main()
{
    //memset(DP, -1, sizeof(DP));
    memset(root, 1, sizeof(root));
    
    scanf("%d%d", &N, &K);
    for (int i = 0; i < N; i++) 
    {
        scanf("%d", &A[i]);
        if (i != 0) sum[i] = sum[i-1] + A[i-1];
    }
    sum[N] = sum[N-1] + A[N-1];
    
    for (int k = N-1; k >= 0; k--)
    {
        DP[k] = DP[k + 1];
        if (root[k+1] <= k + K) DP[k] = max(DP[k], DP[ root[k + 1] + 1] + sum[root[k + 1]] - sum[k]), root[k] = root[k + 1];
        else
         for (int i = k; i <= N && i <= k + K; i++)
         {
             long long t = DP[i + 1] + sum[i] - sum[k];
             if (t > DP[k]) DP[k] = t, root[k] = i;
         }
    }

    cout << DP[0] << endl;
    return 0;
}
