#include <cstdio>
#include <cstdlib>
#include <cmath>
#define maxN 128

typedef struct point {
        double x,y;
        } point;

int L,n;
point list[maxN][2];

void input()
{
     scanf("%d%d",&L,&n);
     for (int i=0;i<n;++i) scanf("%lf%lf%lf%lf",&list[i][0].x,&list[i][0].y,&list[i][1].x,&list[i][1].y);
}

void test(double x, double y)
{
     int i;
     double d,s;
     point v,t;
     for (i=0;i<n;++i) {
         v.x = list[i][1].x - list[i][0].x;
         v.y = list[i][1].y - list[i][0].y;
         d = sqrt(v.x*v.x+v.y*v.y);
         t.x = x - list[i][0].x;
         t.y = y - list[i][0].y;
         s = fabs(v.y*t.x - v.x*t.y);
         if (s <= 50.0*d) return;
         }
     printf("%lf %lf\n",x,y);
     exit(0);
}

void solve()
{
     double x,y,l,step;
     l = (double)L;
     step = l/(sqrt(100000000.0/(double)n));
     step *= 3.3;
     for (x=0.0;x<=l;x+=step)
         for (y=0.0;y<=l;y+=step)
             test(x,y);
     printf("NO WAY\n");
}

int main()
{
    input();
    solve();
    return 0;
}
