#include <iostream>
using namespace std;

typedef float num;
const int maxN = 1005;
const num DV = 1000.0;
num sx[maxN], sy[maxN], tx[maxN], ty[maxN], dm[maxN];

inline bool fk(int l, num x, num y){
	num a = (sx[l] - x)*(ty[l] - y) - (sy[l] - y)*(tx[l] - x);
	a = a*a;
	return a <= dm[l];
}

int main(){
	int i, l, n;
	num eps, px, py, dl;
	
	cin >> l >> n;
	dl = (double)l;
	for(i = 0; i < n; i++)
		cin >> sx[i] >> sy[i] >> tx[i] >> ty[i];

	for(i = 0; i < n; i++){
		dm[i] = 2500.0 * ( (sx[i] - tx[i])*(sx[i] - tx[i]) + (sy[i] - ty[i])*(sy[i] - ty[i]) );
	}

	eps = dl/DV;
	if(eps < 0.68) eps = 0.68;
	px = py = 0.0;

	for(i = 0; i < n; i++){
		if(fk(i, 0.0, 0.0)) goto S1;
	}
	cout << 0.0 << ' ' << 0.0 << endl;
	goto Sydney;
S1:
	for(i = 0; i < n; i++){
		if(fk(i, dl, 0.0)) goto S2; 
	}
	cout << dl << ' ' << 0.0 << endl;
	goto Sydney;
S2:
	for(i = 0; i < n; i++){
		if(fk(i, 0.0, dl)) goto S3;
	}
	cout << 0.0 << ' ' << dl << endl;
	goto Sydney;
S3:
	for(i = 0; i < n; i++){
		if(fk(i, dl, dl)) goto S4;
	}
	cout << dl << ' ' << dl << endl;
	goto Sydney;
S4:
	for(i = 0; i < n; i++){
		if(fk(i, 0.0, dl/2)) goto S5;
	}
	cout << 0.0 << ' ' << dl/2 << endl;
	goto Sydney;
S5:
	for(i = 0; i < n; i++){
		if(fk(i, dl/2, 0.0)) goto S6;
	}
	cout << dl/2 << ' ' << 0.0 << endl;
	goto Sydney;
S6:
	for(i = 0; i < n; i++){
		if(fk(i, dl, dl/2)) goto S7;
	}
	cout << dl << ' ' << dl/2 << endl;
	goto Sydney;
S7:
	for(i = 0; i < n; i++){
		if(fk(i, dl/2, dl)) goto S8;
	}
	cout << dl/2 << ' ' << dl << endl;
	goto Sydney;
S8:
	for(i = 0; i < n; i++){
		if(fk(i, dl/2, dl/2)) goto S9;
	}
	cout << dl/2 << ' ' << dl/2 << endl;
	goto Sydney;
S9:
	while(px < dl){
		while(py < dl){
			for(i = 0; i < n; i++){
				if(fk(i, px, py)) goto NewYork;
			}
			cout << px << ' ' << py << endl;
			goto Sydney;
NewYork:	py += eps;
		}
		px += eps;
	}
	cout << "NO WAY" << endl;
Sydney:
	return 0;
}
